from distutils.core import setup
from distutils import core
from distutils.command.install import install
from distutils.command.build_py import build_py as _build_py
from distutils.core import setup
from subprocess import call

class build_py(_build_py):
    call(["make", "-C", "clustering/mutual3"])


setup(cmdclass={'build_py': build_py},
    name='NetworkTomography-Clustering',
    version='1.0',
    description='Efficient and Reliable Network Tomography Using BitTorrent and Clustering Algorithms. This includes only the clustering component, since it can be decoupled from the preceding measurement or simulation phase',
    author='Kiril Dichev',
    author_email='kiril.dichev@ucdconnect.ie',
    url='http://hcl.ucd.ie/project/network-tomography',
    packages=['clustering'],
    scripts=["clustering/generate-edgelist-incrementally", "clustering/runner2", "clustering/mutual3/mutual"],
    data_files=[('clustering/mutual3', ['clustering/mutual3/makefile', 'clustering/mutual3/mutual3.cpp']), ('clustering/mutual3/standard_package', ['clustering/mutual3/standard_package/mutual.cpp', 'clustering/mutual3/standard_package/cast.cpp', 'clustering/mutual3/standard_package/combinatorics.cpp', 'clustering/mutual3/standard_package/deque_numeric.cpp', 'clustering/mutual3/standard_package/histograms.cpp', 'clustering/mutual3/standard_package/partition.cpp', 'clustering/mutual3/standard_package/print.cpp', 'clustering/mutual3/standard_package/standard_include.cpp', 'clustering/mutual3/standard_package/random.cpp'])]
    )


